/*************************************************************************
 *
 * FILE  exceptions.hpp
 * Copyright (c) 2008 Daniel Kahlin <daniel@kahlin.net>
 * Written by Daniel Kahlin <daniel@kahlin.net>
 * $Id: exceptions.hpp,v 1.1 2008-01-18 21:45:05 tlr Exp $
 *
 * DESCRIPTION 
 *
 ******/
#ifndef EXCEPTIONS_HPP
#define EXCEPTIONS_HPP

struct Exception : public std::exception
{
public:
    Exception(const std::string &str) throw()
    {
	const char* cstr=str.c_str();

	for (int i=0; i<STR_LEN_; ++i) {
	    char c=cstr[i];
	    what_str_[i]=c;
	    if (!c)
		break;
	}
	what_str_[STR_LEN_-1]=0;
    }
    virtual ~Exception() throw() {}
    virtual char const* what() const throw() { return what_str_; }

protected:
    static const int STR_LEN_ = 256;
    char what_str_[STR_LEN_];
};

#endif /* EXCEPTIONS_HPP */
/* eof */
